<?php
namespace Teknisa\PLA\Modules\Medicao\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Cardadiaprato extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "pla0110_cardadia_prato";
    protected $entityManager;
    protected $environment;
    protected $crudService;

	public function __construct($crudService, $entityManager, $dataSourceManager, $environment) {
        $this->crudService = $crudService;
        $this->entityManager = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
    }

	public function updateCardadia(DTO\Request $request, DTO\Response $response) {

        $name = $this->dataSourceName = 'pla0110_cardadia_prato';
        $request = $this->crudService->buildDataSetIfRow($request, $name);

        $row = $request->getDataSet()->getRows();
        $row = (array) $row[0];
        $params = array(
            'nrcardapio' => $row['NRCARDAPIO'],
            'cdfilial' => $row['CDFILIAL'],
            'nrorg' => $this->environment->getNrOrgTrab(),
        );

        $efetivos  = explode(',',$row['QTCOMEFETRI']);
        $comensais = explode(',',$row['QTCOMESTICAR']);

        $cardadia = $this->entityManager->getRepository('\Teknisa\Model\Planejamento\Entities\Cardadia')->findBy($params);
        $cardadia[0]->setQtcomefetri($efetivos[0]);
        $cardadia[0]->setQtcomesticar($comensais[0]);
        $cardadia[0]->setVrpesporpercri($row['VRPESPORPERCRI']);
        $cardadia[0]->setQtrestingeca($row['QTRESTINGECA']);
        $cardadia[0]->setCdmaiorpreri($row['CDMAIORPRERI']);
        $cardadia[0]->setCdfilauxprri($row['CDFILAUXPRRI']);

        $this->entityManager->persist($cardadia[0]);
        $this->entityManager->flush();
    }

    public function setaDataSource(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'pla0110_cardadia_prato';
        
        $conditions = $request->getFilterCriteria()->getConditions();
        $filterCriteria = new FilterCriteria($this->dataSourceName, $conditions);
        
        if ($conditions != []) {
            $cdfilial    = $conditions[0]['value'];
            $cdservfili  = $conditions[1]['value'];
            $dtcardapio  = $conditions[2]['value'];
            $dataInicial = $dtcardapio[0];
            $dataFinal   = $dtcardapio[1];
    
            
            $filterCriteria->addCondition('CDFILIAL', $cdfilial);
            $filterCriteria->addCondition('CDSERVFILI', $cdservfili);
            $filterCriteria->addCondition('NRORG', $this->environment->getNrOrgTrab());
            $filterCriteria->addCondition('DATAINICIAL', $dataInicial);
            $filterCriteria->addCondition('DATAFINAL', $dataFinal);
            
        }
        $newRequest = new DTO\Request\Filter($filterCriteria, null, null, null);
        parent::find($newRequest, $response);
    }
}